window.addEventListener("keydown", function(e){

    switch(e.keyCode){
        case 81:
            on1 = 1;
            break;
        case 87:
            on2 = 1;
            break;
        case 69:
            on3 = 1;
            break;
    }
    
});

window.addEventListener("keyup", function(e){

    switch(e.keyCode){
        case 81:
            on1 = 0;
            break;
        case 87:
            on2 = 0;
            break;
        case 69:
            on3 = 0;
            break;
    }
    
});
                        
window.addEventListener("load", function(){
    
  g = 9.81;
    
  A = 1;
  Aout = 2;
  Abetween = 0.5;
    
  q1 = q2 = q3 = 0;
  qmax = 100;
    
  maxFillWifth = 50;
  fillWidth = 0;
    
  containerHeight = 300;
  containerWidth = 100;
  verticalGap = 30;
  liquidGap = 1;
  topGap = 100;
  verticalTubeBottomGap = 0;
  outTubeWidth = 30;
  verticalTubeHeight = 5;
    
  container1Level = 0.9;
  container2Level = 0.5;
  container3Level = 0.2;
    
  h1 = container1Level * A * containerHeight;
  dh1 = 0;
    
  h2 = container2Level * A * containerHeight;
  dh2 = 0;
    
  h3 = container3Level * A * containerHeight;
  dh3 = 0;
    
  on1 = on2 = on3 = 0;
    
  dt = 0.1;
    
  dq = 1;
        
  canvas = this.__canvas = new fabric.StaticCanvas('canvas');

  canvas.add(
      
    container1 = new fabric.Rect({ top: topGap, left: verticalGap, width: containerWidth, height: containerHeight, fill: 'white', stroke: 'black', strokeWidth: 1, }),
    container1Liquid = new fabric.Rect({ top: topGap + containerHeight - containerHeight*container1Level + liquidGap, left: verticalGap + liquidGap, width: containerWidth - 2*liquidGap, height: containerHeight*container1Level - 2*liquidGap, fill: 'aqua', objectCaching: false}),      
    container1Fill = new fabric.Rect({ top: 0, left: verticalGap + (containerWidth/2) - (fillWidth/2), width: fillWidth, height: containerHeight + topGap -1, fill: 'aqua', objectCaching: false}),
      
    container2 = new fabric.Rect({ top: topGap, left: 2*verticalGap + containerWidth, width: containerWidth, height: containerHeight, fill: 'white', stroke: 'black', strokeWidth: 1, }),
    container2Liquid = new fabric.Rect({ top: topGap + containerHeight - containerHeight*container2Level + liquidGap, left: 2*verticalGap + containerWidth + liquidGap, width: containerWidth - 2*liquidGap, height: containerHeight*container2Level - 2*liquidGap, fill: 'aqua', objectCaching: false}),
    container2Fill = new fabric.Rect({ top: 0, left: 2*verticalGap + 1.5*containerWidth - (fillWidth/2), width: fillWidth, height: containerHeight + topGap -1, fill: 'aqua', objectCaching: false}),
      
    container3 = new fabric.Rect({ top: topGap, left: 3*verticalGap + 2*containerWidth, width: containerWidth, height: containerHeight, fill: 'white', stroke: 'black', strokeWidth: 1, }),
    container3Liquid = new fabric.Rect({ top: topGap + containerHeight - containerHeight*container3Level + liquidGap, left: 3*verticalGap + 2*containerWidth + liquidGap, width: containerWidth - 2*liquidGap, height: containerHeight*container3Level - 2*liquidGap, fill: 'aqua', objectCaching: false}),
    container3Fill = new fabric.Rect({ top: 0, left: 3*verticalGap + 2.5*containerWidth - (fillWidth/2), width: fillWidth, height: containerHeight + topGap -1, fill: 'aqua', objectCaching: false}),

      
    verticalTube12 = new fabric.Rect({ top: topGap + containerHeight - verticalTubeBottomGap - verticalTubeHeight, left: verticalGap + containerWidth, width: verticalGap, height: verticalTubeHeight, fill: 'black', stroke: 'black', strokeWidth: 1, }),
      
    verticalTube23 = new fabric.Rect({ top: topGap + containerHeight - verticalTubeBottomGap - verticalTubeHeight, left: 2*verticalGap + 2*containerWidth, width: verticalGap, height: verticalTubeHeight, fill: 'black', stroke: 'black', strokeWidth: 1, }),
      
    outTube = new fabric.Rect({ top: topGap + containerHeight, left: 2*verticalGap + 1.5*containerWidth - 0.5*outTubeWidth, width: verticalGap, height: verticalTubeHeight, fill: 'black', stroke: 'black', strokeWidth: 1, }),
      
  );
    
  setInterval(reCalculateState, 25);
    
});

function reDrawState(h1, h2, h3, q1, q2, q3){
    container1Level = h1 / ( containerHeight);
    container2Level = h2 / ( containerHeight);
    container3Level = h3 / ( containerHeight);
    
    container1Liquid.top = topGap + containerHeight - containerHeight*container1Level + liquidGap;
    container1Liquid.height = containerHeight*container1Level - 2*liquidGap;
    fillwidth1 = (q1 / qmax) * maxFillWifth;
    container1Fill.width = fillwidth1;
    container1Fill.left = verticalGap + (containerWidth/2) - (fillwidth1/2);
    
    container2Liquid.top = topGap + containerHeight - containerHeight*container2Level + liquidGap;
    container2Liquid.height = containerHeight*container2Level - 2*liquidGap;
    fillwidth2 = (q2 / qmax) * maxFillWifth;
    container2Fill.width = fillwidth2;
    container2Fill.left = 2*verticalGap + 1.5*containerWidth - (fillwidth2/2);
    
    container3Liquid.top = topGap + containerHeight - containerHeight*container3Level + liquidGap;
    container3Liquid.height = containerHeight*container3Level - 2*liquidGap;
    fillwidth3 = (q3 / qmax) * maxFillWifth;
    container3Fill.width = fillwidth3;
    container3Fill.left = 3*verticalGap + 2.5*containerWidth - (fillwidth3/2);
        
    canvas.requestRenderAll();
};

function reCalculateState(){
    if(h1 >= containerHeight){
        q1 = q1 - dq;
    }else{
        q1 = on1 ? q1+dq : q1-dq ;
    }
    q1 = q1 <= 0 ? 0 : q1;
    q1 = q1 > qmax ? qmax : q1;

    if(h2 >= containerHeight){
        q2 = q2 - dq;
    }else{
        q2 = on2 ? q2+dq : q2-dq ;
    }
    q2 = q2 <= 0 ? 0 : q2;
    q2 = q2 > qmax ? qmax : q2;

    
    if(h3 >= containerHeight){
        q3 = q3 - dq;
    }else{
        q3 = on3 ? q3+dq : q3-dq ;
    }
    q3 = q3 <= 0 ? 0 : q3;
    q3 = q3 > qmax ? qmax : q3;

    
    
    dh1 = (1/A) * (q1 + Math.sqrt(2*g*Math.abs(h1-h2)) * Math.sign(h2-h1) * Abetween);
    
    dh2 = (1/A) * (q2 + Math.sqrt(2*g*Math.abs(h1-h2)) * Math.sign(h1-h2) * Abetween + 
                        Math.sqrt(2*g*Math.abs(h2-h3)) * Math.sign(h3-h2) * Abetween - 
                        Math.sqrt(Math.abs(2*g*h2)) * Aout);

    dh3 = (1/A) * (q3 + Math.sqrt(2*g*Math.abs(h2-h3)) * Math.sign(h2-h3) * Abetween);
    
    h1 += dh1*dt;
    h2 += dh2*dt;
    h3 += dh3*dt;
    
    h1 = h1 >= containerHeight ? containerHeight : h1;
    h1 = h1 <= 2 ? 2 : h1;
    
    h2 = h2 >= containerHeight ? containerHeight: h2;
    h2 = h2 <= 2 ? 2 : h2;
    
    h3 = h3 >= containerHeight ? containerHeight: h3;
    h3 = h3 <= 2 ? 2 : h3;
 
    reDrawState(h1, h2, h3, q1, q2, q3);
}